/* -*- c++ -*- */
/* 
 * Copyright 2016 <+YOU OR YOUR COMPANY+>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */


#ifndef INCLUDED_THEREMIN_TH_MEAN_H
#define INCLUDED_THEREMIN_TH_MEAN_H

#include <theremin/api.h>
#include <gnuradio/block.h>
//#include <gnuradio/sync_block.h>
//#include <gnuradio/sync_decimator.h>

namespace gr {
  namespace theremin {

    /*!
     * \brief <+description of block+>
     * \ingroup theremin
     *
     */
    class THEREMIN_API th_mean : virtual public gr::block
    //class THEREMIN_API th_mean : virtual public sync_decimator
    //class THEREMIN_API th_mean : virtual public sync_block
    {
     public:
      typedef boost::shared_ptr<th_mean> sptr;

      /*!
       * \brief Return a shared_ptr to a new instance of theremin::th_mean.
       *
       * To avoid accidental use of raw pointers, theremin::th_mean's
       * constructor is in a private implementation
       * class. theremin::th_mean::make is the public interface for
       * creating new instances.
       */
      static sptr make(int mean_length, float threshold);
    };

  } // namespace theremin
} // namespace gr

#endif /* INCLUDED_THEREMIN_TH_MEAN_H */

